<?php
/*
Plugin Name: PixoPoint Adsense
Plugin URI: http://pixopoint.com/
Description: Allows users to add Google Adsense code to their sites. Intended for WordPress Multi-sites, not standalone installs.
Author: PixoPoint
Version: 0.1
Author URI: http://pixopoint.com/
*/

/**
 * Content parser
 * Converts JS into WordPress shortcode
 * @since 0.1
 */
function pixopoint_adsense_filter( $content ) {

	// WordPress converts " into \" so needed to convert them back to make sure it's all kosher for the regex :)
	$content = str_replace( '\"', '"', $content );

	// Convert JS into shortcode
	$content = preg_replace(
		'/<script.*?'
		. 'ad_client\s*=\s*"([^"]+?)"' . '.*?'
		. 'ad_slot\s*=\s*"([^"]+?)"'   . '.*?'
		. 'width\s*=\s*(\d+)'          . '.*?'
		. 'height\s*=\s*(\d+)'         . '.*?'
		. '<\/script>'                  . '.*?'
		. '<\/script>'                  . '.*?'
		. '/mis', '[adsense client="$1" slot="$2" width="$3" height="$4"]',
		$content
	);

	return $content;
}
add_filter( 'content_save_pre', 'pixopoint_adsense_filter' );

/**
 * Adsense shortcode
 * @since 0.1
 */
function pixopoint_adsense_shortcode( $atts ) {
	extract(
		shortcode_atts(
			array(
				'client'   => '',
				'slot'     => '',
				'width'    => '',
				'height'   => '',
			),
			$atts
		)
	);

	// Santization of inputs
	$client = sanitize_title( wp_kses( $client, '' ) ); // Strip out nasties - use sanitize title coz it does a good job of stripping out anything but alphanumerics and dashes which is what is in the Adsense client code
	$slot   = sanitize_title( wp_kses( $slot , '' ) ); // Strip out nasties - use sanitize title coz it does a good job of stripping out anything but alphanumerics and dashes which is what is in the Adsense client code
	$width  = absint( $width ); // Confirm integer
	$height = absint( $width ); // Confirm integer

	// Spit out the Adsense script
	echo '
<script type="text/javascript"><!--
	google_ad_client = "' . $client . '";
	google_ad_slot = "' . $slot . '";
	google_ad_width = ' . $width . ';
	google_ad_height = ' . $height . ';
//-->
</script>
<script type="text/javascript" src="http://pagead2.googlesyndication.com/pagead/show_ads.js"></script>
';
}
add_shortcode( 'adsense', 'pixopoint_adsense_shortcode' );

